Index: sasmodels/model_test.py
===================================================================
--- sasmodels/model_test.py	(revision 9404dd3f599fcbe72790aae8a6d176e64f292ea6)
+++ sasmodels/model_test.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -9,5 +9,5 @@
     if model1 is 'all', then all except the remaining models will be tested
 
-Each model is tested using the default parameters at q=0.1, (qx,qy)=(0.1,0.1),
+Each model is tested using the default parameters at q=0.1, (qx, qy)=(0.1, 0.1),
 and the ER and VR are computed.  The return values at these points are not
 considered.  The test is only to verify that the models run to completion,
@@ -30,5 +30,5 @@
         [ {parameters}, (qx, qy), I(qx, Iqy)],
         [ {parameters}, [(qx1, qy1), (qx2, qy2), ...],
-                        [I(qx1,qy1), I(qx2,qy2), ...]],
+                        [I(qx1, qy1), I(qx2, qy2), ...]],
 
         [ {parameters}, 'ER', ER(pars) ],
@@ -43,4 +43,5 @@
 Precision defaults to 5 digits (relative).
 """
+from __future__ import print_function
 
 import sys
@@ -55,4 +56,13 @@
 
 def make_suite(loaders, models):
+    """
+    Construct the pyunit test suite.
+
+    *loaders* is the list of kernel drivers to use, which is one of
+    *["dll", "opencl"]*, *["dll"]* or *["opencl"]*.  For python models,
+    the python driver is always used.
+
+    *models* is the list of models to test, or *["all"]* to test all models.
+    """
 
     ModelTestCase = _hide_model_case_from_nosetests()
@@ -75,5 +85,5 @@
         # don't try to call cl kernel since it will not be
         # available in some environmentes.
-        is_py = callable(getattr(model_definition,'Iq', None))
+        is_py = callable(getattr(model_definition, 'Iq', None))
 
         if is_py:  # kernel implemented in python
@@ -90,7 +100,11 @@
                 test_name = "Model: %s, Kernel: OpenCL"%model_name
                 test_method_name = "test_%s_opencl" % model_name
+                # Using dtype=None so that the models that are only
+                # correct for double precision are not tested using
+                # single precision.  The choice is determined by the
+                # presence of *single=False* in the model file.
                 test = ModelTestCase(test_name, model_definition,
                                      test_method_name,
-                                     platform="ocl", dtype='single')
+                                     platform="ocl", dtype=None)
                 #print("defining", test_name)
                 suite.addTest(test)
@@ -111,4 +125,11 @@
 def _hide_model_case_from_nosetests():
     class ModelTestCase(unittest.TestCase):
+        """
+        Test suit for a particular model with a particular kernel driver.
+
+        The test suite runs a simple smoke test to make sure the model
+        functions, then runs the list of tests at the bottom of the model
+        description file.
+        """
         def __init__(self, test_name, definition, test_method_name,
                      platform, dtype):
@@ -123,8 +144,8 @@
         def _runTest(self):
             smoke_tests = [
-                [{},0.1,None],
-                [{},(0.1,0.1),None],
-                [{},'ER',None],
-                [{},'VR',None],
+                [{}, 0.1, None],
+                [{}, (0.1, 0.1), None],
+                [{}, 'ER', None],
+                [{}, 'VR', None],
                 ]
 
@@ -140,5 +161,5 @@
                     ## values an error.  Only do so for the "dll" tests
                     ## to reduce noise from both opencl and dll, and because
-                    ## python kernels us
+                    ## python kernels use platform="dll".
                     #raise Exception("No test cases provided")
                     pass
@@ -163,5 +184,5 @@
                 actual = [call_VR(model.info, pars)]
             elif isinstance(x[0], tuple):
-                Qx,Qy = zip(*x)
+                Qx, Qy = zip(*x)
                 q_vectors = [np.array(Qx), np.array(Qy)]
                 kernel = make_kernel(model, q_vectors)
@@ -179,14 +200,19 @@
                     # smoke test --- make sure it runs and produces a value
                     self.assertTrue(np.isfinite(actual_yi),
-                        'invalid f(%s): %s' % (xi, actual_yi))
+                                    'invalid f(%s): %s' % (xi, actual_yi))
                 else:
-                    err = abs(yi - actual_yi)
-                    nrm = abs(yi)
-                    self.assertLess(err * 10**5, nrm,
-                        'f(%s); expected:%s; actual:%s' % (xi, yi, actual_yi))
+                    self.assertTrue(is_near(yi, actual_yi, 5),
+                                    'f(%s); expected:%s; actual:%s'
+                                    % (xi, yi, actual_yi))
 
     return ModelTestCase
 
-
+def is_near(target, actual, digits=5):
+    """
+    Returns true if *actual* is within *digits* significant digits of *target*.
+    """
+    import math
+    shift = 10**math.ceil(math.log10(abs(target)))
+    return abs(target-actual)/shift < 1.5*10**-digits
 
 def main():
@@ -199,4 +225,9 @@
 
     models = sys.argv[1:]
+    if models and models[0] == '-v':
+        verbosity = 2
+        models = models[1:]
+    else:
+        verbosity = 1
     if models and models[0] == 'opencl':
         if not HAVE_OPENCL:
@@ -217,14 +248,18 @@
         print("""\
 usage:
-  python -m sasmodels.model_test [opencl|dll|opencl_and_dll] model1 model2 ...
+  python -m sasmodels.model_test [-v] [opencl|dll] model1 model2 ...
+
+If -v is included on the
+If neither opencl nor dll is specified, then models will be tested with
+both opencl and dll; the compute target is ignored for pure python models.
 
 If model1 is 'all', then all except the remaining models will be tested.
-If no compute target is specified, then models will be tested with both opencl
-and dll; the compute target is ignored for pure python models.""")
+
+""")
 
         return 1
 
     #runner = unittest.TextTestRunner()
-    runner = xmlrunner.XMLTestRunner(output='logs')
+    runner = xmlrunner.XMLTestRunner(output='logs', verbosity=verbosity)
     result = runner.run(make_suite(loaders, models))
     return 1 if result.failures or result.errors else 0
@@ -237,5 +272,5 @@
     Run "nosetests sasmodels" on the command line to invoke it.
     """
-    tests = make_suite(['opencl','dll'],['all'])
+    tests = make_suite(['opencl', 'dll'], ['all'])
     for test_i in tests:
         yield test_i._runTest
Index: sasmodels/models/HayterMSAsq.py
===================================================================
--- sasmodels/models/HayterMSAsq.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/HayterMSAsq.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -56,4 +56,5 @@
         parameters used in P(Q).
 """
+single = False  # double precision only for now
 #             [ "name", "units", default, [lower, upper], "type", "description" ],
 parameters = [["effect_radius", "Ang", 20.75, [0, inf], "volume",
@@ -90,3 +91,9 @@
 # odd that the default st has saltconc zero
 demo = dict(effect_radius = 20.75,charge=19.0,volfraction = 0.0192,temperature=318.16,saltconc=0.05,dielectconst=71.08,effect_radius_pd = 0.1,effect_radius_pd_n = 40)
+#
+# attempt to use same values as old sasview unit test
+tests = [
+        [ {'scale': 1.0, 'background' : 0.0, 'effect_radius' : 20.75, 'charge' : 19.0, 'volfraction' : 0.0192, 'temperature' : 298.0,
+          'saltconc' : 0,'dielectconst' : 78.0, 'effect_radius_pd' : 0}, [0.0010], [0.0712928]]
+        ]
 
Index: sasmodels/models/barbell.py
===================================================================
--- sasmodels/models/barbell.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/barbell.py	(revision dcdf29d606cfaa2f3bb9d578ac394c6f167fa360)
@@ -100,20 +100,24 @@
 title = "Cylinder with spherical end caps"
 description = """
-        Calculates the scattering from a barbell-shaped cylinder. That is a sphereocylinder with spherical end caps that have a radius larger than that of the cylinder and the center of the end cap
-        radius lies outside of the cylinder.
-        Note: As the length of cylinder(bar) -->0,it becomes a dumbbell. And when rad_bar = rad_bell, it is a spherocylinder.
-        It must be that rad_bar <(=) rad_bell.
+    Calculates the scattering from a barbell-shaped cylinder.
+    That is a sphereocylinder with spherical end caps that have a radius larger
+    than that of the cylinder and the center of the end cap radius lies outside
+    of the cylinder.
+    Note: As the length of cylinder(bar) -->0,it becomes a dumbbell. And when
+    rad_bar = rad_bell, it is a spherocylinder.
+    It must be that rad_bar <(=) rad_bell.
 """
 category = "shape:cylinder"
-
+# pylint: disable=bad-whitespace, line-too-long
 #             ["name", "units", default, [lower, upper], "type","description"],
-parameters = [["sld", "4e-6/Ang^2", 4, [-inf, inf], "", "Barbell scattering length density"],
-              ["solvent_sld", "1e-6/Ang^2", 1, [-inf, inf], "", "Solvent scattering length density"],
-              ["bell_radius", "Ang", 40, [0, inf], "volume", "Spherical bell radius"],
-              ["radius", "Ang", 20, [0, inf], "volume", "Cylindrical bar radius"],
-              ["length", "Ang", 400, [0, inf], "volume", "Cylinder bar length"],
-              ["theta", "degrees", 60, [-inf, inf], "orientation", "In plane angle"],
-              ["phi", "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"],
+parameters = [["sld",         "4e-6/Ang^2",   4, [-inf, inf], "",            "Barbell scattering length density"],
+              ["solvent_sld", "1e-6/Ang^2",   1, [-inf, inf], "",            "Solvent scattering length density"],
+              ["bell_radius", "Ang",         40, [0, inf],    "volume",      "Spherical bell radius"],
+              ["radius",      "Ang",         20, [0, inf],    "volume",      "Cylindrical bar radius"],
+              ["length",      "Ang",        400, [0, inf],    "volume",      "Cylinder bar length"],
+              ["theta",       "degrees",     60, [-inf, inf], "orientation", "In plane angle"],
+              ["phi",         "degrees",     60, [-inf, inf], "orientation", "Out of plane angle"],
              ]
+# pylint: enable=bad-whitespace, line-too-long
 
 source = ["lib/J1.c", "lib/gauss76.c", "barbell.c"]
Index: sasmodels/models/bcc.py
===================================================================
--- sasmodels/models/bcc.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/bcc.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -109,20 +109,26 @@
 title = "Body-centred cubic lattic with paracrystalline distortion"
 description = """
-    Calculates the scattering from a **body-centered cubic lattice** with paracrystalline distortion. Thermal vibrations
-    are considered to be negligible, and the size of the paracrystal is infinitely large. Paracrystalline distortion is
-    assumed to be isotropic and characterized by a Gaussian distribution.
+    Calculates the scattering from a **body-centered cubic lattice** with
+    paracrystalline distortion. Thermal vibrations are considered to be
+    negligible, and the size of the paracrystal is infinitely large.
+    Paracrystalline distortion is assumed to be isotropic and characterized
+    by a Gaussian distribution.
     """
 category = "shape:paracrystal"
 
+single = False
+
+# pylint: disable=bad-whitespace, line-too-long
 #             ["name", "units", default, [lower, upper], "type","description" ],
-parameters = [["dnn", "Ang", 220, [-inf, inf], "", "Nearest neighbour distance"],
-              ["d_factor", "", 0.06, [-inf, inf], "", "Paracrystal distortion factor"],
-              ["radius", "Ang", 40, [0, inf], "volume", "Particle radius"],
-              ["sld", "1e-6/Ang^2", 4, [-inf, inf], "", "Particle scattering length density"],
-              ["solvent_sld", "1e-6/Ang^2", 1, [-inf, inf], "", "Solvent scattering length density"],
-              ["theta", "degrees", 60, [-inf, inf], "orientation", "In plane angle"],
-              ["phi", "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"],
-              ["psi", "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"]
+parameters = [["dnn",         "Ang",       220,    [-inf, inf], "",            "Nearest neighbour distance"],
+              ["d_factor",    "",            0.06, [-inf, inf], "",            "Paracrystal distortion factor"],
+              ["radius",      "Ang",        40,    [0, inf],    "volume",      "Particle radius"],
+              ["sld",         "1e-6/Ang^2",  4,    [-inf, inf], "",            "Particle scattering length density"],
+              ["solvent_sld", "1e-6/Ang^2",  1,    [-inf, inf], "",            "Solvent scattering length density"],
+              ["theta",       "degrees",    60,    [-inf, inf], "orientation", "In plane angle"],
+              ["phi",         "degrees",    60,    [-inf, inf], "orientation", "Out of plane angle"],
+              ["psi",         "degrees",    60,    [-inf, inf], "orientation", "Out of plane angle"]
              ]
+# pylint: enable=bad-whitespace, line-too-long
 
 source = ["lib/J1.c", "lib/gauss150.c", "bcc.c"]
Index: sasmodels/models/be_polyelectrolyte.py
===================================================================
--- sasmodels/models/be_polyelectrolyte.py	(revision 168052c5791506d7dfad00173f5636fc5701ad11)
+++ sasmodels/models/be_polyelectrolyte.py	(revision 168052c5791506d7dfad00173f5636fc5701ad11)
@@ -0,0 +1,196 @@
+r"""
+This model calculates the structure factor of a polyelectrolyte solution with
+the RPA expression derived by Borue and Erukhimovich.
+
+Definition
+----------
+
+The scattering intensity $I(q)$ is calculated as
+
+.. math::
+
+    I(q) = K\frac{q^2+k^2}{4\pi L\alpha ^2}
+    \frac{1}{1+r_{0}^2(q^2+k^2)(q^2-12hC_a/b^2)} + background
+
+    k^2 = 4\pi L(2C_s + \alpha C_a)
+
+    r_{0}^2 = \frac{1}{\alpha \sqrt{C_a} \left( b/\sqrt{48\pi L_b}\right)}
+
+where $K$ is the contrast factor for the polymer, $L_b$ is the Bjerrum length,
+$h$ is the virial parameter, $b$ is the monomer length,
+$C_s$ is the concentration of monovalent salt, $\alpha$ is the ionization
+degree, $C_a$ is the polymer molar concentration, and $background$ is the
+incoherent background.
+
+For 2D data the scattering intensity is calculated in the same way as 1D,
+where the $q$ vector is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+.. figure:: img/be_polyelectrolyte_1d.jpg
+
+    1D plot using the default values (w/500 data point).
+
+NB: $1 barn = 10^{-24} cm^2$
+
+References
+----------
+
+V Y Borue, I Y Erukhimovich, *Macromolecules*, 21 (1988) 3240
+
+J F Joanny, L Leibler, *Journal de Physique*, 51 (1990) 545
+
+A Moussaid, F Schosseler, J P Munch, S Candau,
+*J. Journal de Physique II France*, 3 (1993) 573
+
+E Raphael, J F Joanny, *Europhysics Letters*, 11 (1990) 179
+
+"""
+
+from numpy import inf, pi, sqrt
+
+name = "be_polyelectrolyte"
+title = "Polyelectrolyte with the RPA expression derived by Borue and Erukhimovich"
+description = """
+            Evaluate
+            F(x) = K 1/(4 pi Lb (alpha)^(2)) (q^(2)+k2)/(1+(r02)^(2))
+                 (q^(2)+k2) (q^(2)-(12 h C/b^(2)))
+
+            has 3 internal parameters :
+                   The inverse Debye Length: K2 = 4 pi Lb (2 Cs+alpha C)
+                   r02 =1/alpha/Ca^(0.5) (B/(48 pi Lb)^(0.5))
+                   Ca = 6.022136e-4 C
+            """
+category = "shape-independent"
+
+# pylint: disable=bad-whitespace, line-too-long
+#   ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["contrast_factor",       "barns",   10.0,  [-inf, inf], "", "Contrast factor of the polymer"],
+    ["bjerrum_length",        "Ang",      7.1,  [0, inf],    "", "Bjerrum length"],
+    ["virial_param",          "1/Ang^2", 12.0,  [-inf, inf], "", "Virial parameter"],
+    ["monomer_length",        "Ang",     10.0,  [0, inf],    "", "Monomer length"],
+    ["salt_concentration",    "mol/L",    0.0,  [-inf, inf], "", "Concentration of monovalent salt"],
+    ["ionization_degree",     "",         0.05, [0, inf],    "", "Degree of ionization"],
+    ["polymer_concentration", "mol/L",    0.7,  [0, inf],    "", "Polymer molar concentration"],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+
+
+def Iq(q,
+       contrast_factor=10.0,
+       bjerrum_length=7.1,
+       virial_param=12.0,
+       monomer_length=10.0,
+       salt_concentration=0.0,
+       ionization_degree=0.05,
+       polymer_concentration=0.7):
+    """
+    :param q:                     Input q-value
+    :param contrast_factor:       Contrast factor of the polymer
+    :param bjerrum_length:        Bjerrum length
+    :param virial_param:          Virial parameter
+    :param monomer_length:        Monomer length
+    :param salt_concentration:    Concentration of monovalent salt
+    :param ionization_degree:     Degree of ionization
+    :param polymer_concentration: Polymer molar concentration
+    :return:                      1-D intensity
+    """
+
+    concentration = polymer_concentration * 6.022136e-4
+
+    k_square = 4.0 * pi * bjerrum_length * (2*salt_concentration +
+                                            ionization_degree * concentration)
+
+    r0_square = 1.0/ionization_degree/sqrt(concentration) * \
+                (monomer_length/sqrt((48.0*pi*bjerrum_length)))
+
+    term1 = contrast_factor/(4.0 * pi * bjerrum_length *
+                             ionization_degree**2) * (q**2 + k_square)
+
+    term2 = 1.0 + r0_square**2 * (q**2 + k_square) * \
+        (q**2 - (12.0 * virial_param * concentration/(monomer_length**2)))
+
+    return term1/term2
+
+Iq.vectorized = True  # Iq accepts an array of q values
+
+
+def Iqxy(qx, qy, *args):
+    """
+    :param qx:   Input q_x-value
+    :param qy:   Input q_y-value
+    :param args: Remaining arguments
+    :return:     2D-Intensity
+    """
+    iq = Iq(sqrt(qx**2 + qy**2), *args)
+    return iq
+
+Iqxy.vectorized = True  # Iqxy accepts an array of qx, qy values
+
+
+demo = dict(scale=1, background=0.1,
+            contrast_factor=10.0,
+            bjerrum_length=7.1,
+            virial_param=12.0,
+            monomer_length=10.0,
+            salt_concentration=0.0,
+            ionization_degree=0.05,
+            polymer_concentration=0.7)
+
+oldname = "BEPolyelectrolyte"
+
+oldpars = dict(background='background',
+               contrast_factor='k',
+               bjerrum_length='lb',
+               virial_param='h',
+               monomer_length='b',
+               salt_concentration='cs',
+               ionization_degree='alpha',
+               polymer_concentration='c')
+
+tests = [
+
+    # Accuracy tests based on content in test/utest_other_models.py
+    [{'contrast_factor':       10.0,
+      'bjerrum_length':         7.1,
+      'virial_param':          12.0,
+      'monomer_length':        10.0,
+      'salt_concentration':     0.0,
+      'ionization_degree':      0.05,
+      'polymer_concentration':  0.7,
+      'background':             0.001,
+     }, 0.001, 0.0948379],
+
+    # Additional tests with larger range of parameters
+    [{'contrast_factor':       10.0,
+      'bjerrum_length':       100.0,
+      'virial_param':           3.0,
+      'monomer_length':         1.0,
+      'salt_concentration':    10.0,
+      'ionization_degree':      2.0,
+      'polymer_concentration': 10.0,
+     }, 0.1, -3.75693800588],
+
+    [{'contrast_factor':       10.0,
+      'bjerrum_length':       100.0,
+      'virial_param':           3.0,
+      'monomer_length':         1.0,
+      'salt_concentration':    10.0,
+      'ionization_degree':      2.0,
+      'polymer_concentration': 10.0,
+      'background':           100.0
+     }, 5.0, 100.029142149],
+
+    [{'contrast_factor':     100.0,
+      'bjerrum_length':       10.0,
+      'virial_param':        180.0,
+      'monomer_length':        1.0,
+      'salt_concentration':    0.1,
+      'ionization_degree':     0.5,
+      'polymer_concentration': 0.1,
+     }, 200., 1.80664667511e-06],
+    ]
Index: sasmodels/models/broad_peak.py
===================================================================
--- sasmodels/models/broad_peak.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/broad_peak.py	(revision dcdf29d606cfaa2f3bb9d578ac394c6f167fa360)
@@ -60,14 +60,33 @@
 category = "shape-independent"
 
+# pylint: disable=bad-whitespace, line-too-long
 #             ["name", "units", default, [lower, upper], "type", "description"],
-parameters = [["porod_scale", "", 1.0e-05, [-inf, inf], "", "Power law scale factor"],
-              ["porod_exp", "", 3.0, [-inf, inf], "", "Exponent of power law"],
-              ["lorentz_scale", "", 10.0, [-inf, inf], "", "Scale factor for broad Lorentzian peak"],
-              ["lorentz_length", "Ang", 50.0, [-inf, inf], "", "Lorentzian screening length"],
-              ["peak_pos", "1/Ang", 0.1, [-inf, inf], "", "Peak postion in q"],
-              ["lorentz_exp", "", 2.0, [-inf, inf], "", "exponent of Lorentz function"],
+parameters = [["porod_scale",    "",  1.0e-05, [-inf, inf], "", "Power law scale factor"],
+              ["porod_exp",      "",      3.0, [-inf, inf], "", "Exponent of power law"],
+              ["lorentz_scale",  "",     10.0, [-inf, inf], "", "Scale factor for broad Lorentzian peak"],
+              ["lorentz_length", "Ang",  50.0, [-inf, inf], "", "Lorentzian screening length"],
+              ["peak_pos",       "1/Ang", 0.1, [-inf, inf], "", "Peak position in q"],
+              ["lorentz_exp",    "",      2.0, [-inf, inf], "", "Exponent of Lorentz function"],
              ]
+# pylint: enable=bad-whitespace, line-too-long
 
-def Iq(q, porod_scale, porod_exp, lorentz_scale, lorentz_length, peak_pos, lorentz_exp):
+def Iq(q,
+       porod_scale=1.0e-5,
+       porod_exp=3.0,
+       lorentz_scale=10.0,
+       lorentz_length=50.0,
+       peak_pos=0.1,
+       lorentz_exp=2.0):
+    """
+    :param q:              Input q-value
+    :param porod_scale:    Power law scale factor
+    :param porod_exp:      Exponent of power law
+    :param lorentz_scale:  Scale factor for broad Lorentzian peak
+    :param lorentz_length: Lorentzian screening length
+    :param peak_pos:       Peak position in q
+    :param lorentz_exp:    Exponent of Lorentz function
+    :return:               Calculated intensity
+    """
+
     inten = (porod_scale / q ** porod_exp + lorentz_scale
              / (1.0 + (abs(q - peak_pos) * lorentz_length) ** lorentz_exp))
@@ -76,7 +95,13 @@
 
 def Iqxy(qx, qy, *args):
+    """
+    :param qx:   Input q_x-value
+    :param qy:   Input q_y-value
+    :param args: Remaining arguments
+    :return:     2D-Intensity
+    """
     return Iq(sqrt(qx ** 2 + qy ** 2), *args)
+
 Iqxy.vectorized = True # Iqxy accepts an array of qx, qy values
-
 
 demo = dict(scale=1, background=0,
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/capped_cylinder.py	(revision dcdf29d606cfaa2f3bb9d578ac394c6f167fa360)
@@ -125,11 +125,10 @@
 """
 category = "shape:cylinder"
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [["sld",         "1e-6/Ang^2", 4, [-inf, inf], "",       "Cylinder scattering length density"],
+              ["solvent_sld", "1e-6/Ang^2", 1, [-inf, inf], "",       "Solvent scattering length density"],
+              ["radius",      "Ang",       20, [0, inf],    "volume", "Cylinder radius"],
 
-#             ["name", "units", default, [lower, upper], "type", "description"],
-parameters = [["sld", "1e-6/Ang^2", 4, [-inf, inf], "",
-               "Cylinder scattering length density"],
-              ["solvent_sld", "1e-6/Ang^2", 1, [-inf, inf], "",
-               "Solvent scattering length density"],
-              ["radius", "Ang", 20, [0, inf], "volume", "Cylinder radius"],
               # TODO: use an expression for cap radius with fixed bounds.
               # The current form requires cap radius R bigger than cylinder radius r.
@@ -141,9 +140,10 @@
               # in the capped cylinder, and zero for no bar in the barbell model.  In
               # both models, one would be a pill.
-              ["cap_radius", "Ang", 20, [0, inf], "volume", "Cap radius"],
-              ["length", "Ang", 400, [0, inf], "volume", "Cylinder length"],
-              ["theta", "degrees", 60, [-inf, inf], "orientation", "In plane angle"],
-              ["phi", "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"],
+              ["cap_radius", "Ang",     20, [0, inf],    "volume", "Cap radius"],
+              ["length",     "Ang",    400, [0, inf],    "volume", "Cylinder length"],
+              ["theta",      "degrees", 60, [-inf, inf], "orientation", "In plane angle"],
+              ["phi",        "degrees", 60, [-inf, inf], "orientation", "Out of plane angle"],
              ]
+# pylint: enable=bad-whitespace, line-too-long
 
 source = ["lib/J1.c", "lib/gauss76.c", "capped_cylinder.c"]
@@ -159,4 +159,7 @@
             phi_pd=15, phi_pd_n=1)
 oldname = 'CappedCylinderModel'
-oldpars = dict(sld='sld_capcyl', solvent_sld='sld_solv',
-               length='len_cyl', radius='rad_cyl', cap_radius='rad_cap')
+oldpars = dict(sld='sld_capcyl',
+               solvent_sld='sld_solv',
+               length='len_cyl',
+               radius='rad_cyl',
+               cap_radius='rad_cap')
Index: sasmodels/models/core_shell_bicelle.c
===================================================================
--- sasmodels/models/core_shell_bicelle.c	(revision 8007311db20a23588c62551c8a69f089cf8835e1)
+++ sasmodels/models/core_shell_bicelle.c	(revision 8007311db20a23588c62551c8a69f089cf8835e1)
@@ -0,0 +1,209 @@
+double form_volume(double radius, double rim_thickness, double face_thickness, double length);
+double Iq(double q,
+          double radius,
+          double rim_thickness,
+          double face_thickness,
+          double length,
+          double core_sld,
+          double face_sld,
+          double rim_sld,
+          double solvent_sld);
+
+
+double Iqxy(double qx, double qy,
+          double radius,
+          double rim_thickness,
+          double face_thickness,
+          double length,
+          double core_sld,
+          double face_sld,
+          double rim_sld,
+          double solvent_sld,
+          double theta,
+          double phi);
+
+
+double form_volume(double radius, double rim_thickness, double face_thickness, double length)
+{
+    return M_PI*(radius+rim_thickness)*(radius+rim_thickness)*(length+2*face_thickness);
+}
+
+static double
+bicelle_kernel(double qq,
+              double rad,
+              double radthick,
+              double facthick,
+              double length,
+              double rhoc,
+              double rhoh,
+              double rhor,
+              double rhosolv,
+              double dum)
+{
+	double dr1,dr2,dr3;
+	double besarg1,besarg2;
+	double vol1,vol2,vol3;
+	double sinarg1,sinarg2;
+	double t1,t2,t3;
+	double retval,si1,si2,be1,be2;
+
+	dr1 = rhoc-rhoh;
+	dr2 = rhor-rhosolv;
+	dr3=  rhoh-rhor;
+	vol1 = M_PI*rad*rad*(2.0*length);
+	vol2 = M_PI*(rad+radthick)*(rad+radthick)*(2.0*length+2.0*facthick);
+	vol3= M_PI*(rad)*(rad)*(2.0*length+2.0*facthick);
+	besarg1 = qq*rad*sin(dum);
+	besarg2 = qq*(rad+radthick)*sin(dum);
+	sinarg1 = qq*length*cos(dum);
+	sinarg2 = qq*(length+facthick)*cos(dum);
+
+	if(besarg1 == 0) {
+		be1 = 0.5;
+	} else {
+		be1 = J1(besarg1)/besarg1;
+	}
+	if(besarg2 == 0) {
+		be2 = 0.5;
+	} else {
+		be2 = J1(besarg2)/besarg2;
+	}
+	if(sinarg1 == 0) {
+		si1 = 1.0;
+	} else {
+		si1 = sin(sinarg1)/sinarg1;
+	}
+	if(sinarg2 == 0) {
+		si2 = 1.0;
+	} else {
+		si2 = sin(sinarg2)/sinarg2;
+	}
+	t1 = 2.0*vol1*dr1*si1*be1;
+	t2 = 2.0*vol2*dr2*si2*be2;
+	t3 = 2.0*vol3*dr3*si2*be1;
+
+	retval = ((t1+t2+t3)*(t1+t2+t3))*sin(dum);
+	return(retval);
+
+}
+
+static double
+bicelle_integration(double qq,
+                   double rad,
+                   double radthick,
+                   double facthick,
+                   double length,
+                   double rhoc,
+                   double rhoh,
+                   double rhor,
+                   double rhosolv)
+{
+
+
+	double answer,halfheight;
+	double lolim,uplim,summ,yyy,zi;
+	int nord,i;
+
+	// set up the integration end points
+	nord = 76;
+	lolim = 0.0;
+	uplim = M_PI/2;
+	halfheight = length/2.0;
+
+	summ = 0.0;
+	i=0;
+	for(i=0;i<nord;i++) {
+		zi = ( Gauss76Z[i]*(uplim-lolim) + uplim + lolim )/2.0;
+		yyy = Gauss76Wt[i] * bicelle_kernel(qq, rad, radthick, facthick,
+		                     halfheight, rhoc, rhoh, rhor,rhosolv, zi);
+		summ += yyy;
+	}
+
+	// calculate value of integral to return
+	answer = (uplim-lolim)/2.0*summ;
+	return(answer);
+}
+
+static double
+bicelle_kernel_2d(double q, double q_x, double q_y,
+          double radius,
+          double rim_thickness,
+          double face_thickness,
+          double length,
+          double core_sld,
+          double face_sld,
+          double rim_sld,
+          double solvent_sld,
+          double theta,
+          double phi)
+{
+    double cyl_x, cyl_y;
+    double alpha, cos_val;
+    double answer;
+
+    //convert angle degree to radian
+    theta *= M_PI/180.0;
+    phi *= M_PI/180.0;
+
+    // Cylinder orientation
+    cyl_x = cos(theta) * cos(phi);
+    cyl_y = sin(theta);
+
+    // Compute the angle btw vector q and the axis of the cylinder
+    cos_val = cyl_x*q_x + cyl_y*q_y;
+    alpha = acos( cos_val );
+
+    // Get the kernel
+    answer = bicelle_kernel(q, radius, rim_thickness, face_thickness,
+                           length/2.0, core_sld, face_sld, rim_sld,
+                           solvent_sld, alpha) / fabs(sin(alpha));
+
+    answer *= 1.0e-4;
+
+    return answer;
+}
+
+double Iq(double q,
+          double radius,
+          double rim_thickness,
+          double face_thickness,
+          double length,
+          double core_sld,
+          double face_sld,
+          double rim_sld,
+          double solvent_sld)
+{
+    double intensity = bicelle_integration(q, radius, rim_thickness, face_thickness,
+                       length, core_sld, face_sld, rim_sld, solvent_sld);
+    return intensity*1.0e-4;
+}
+
+
+double Iqxy(double qx, double qy,
+          double radius,
+          double rim_thickness,
+          double face_thickness,
+          double length,
+          double core_sld,
+          double face_sld,
+          double rim_sld,
+          double solvent_sld,
+          double theta,
+          double phi)
+{
+    double q;
+    q = sqrt(qx*qx+qy*qy);
+    double intensity = bicelle_kernel_2d(q, qx/q, qy/q,
+                      radius,
+                      rim_thickness,
+                      face_thickness,
+                      length,
+                      core_sld,
+                      face_sld,
+                      rim_sld,
+                      solvent_sld,
+                      theta,
+                      phi);
+
+    return intensity;
+}
